/*The Sierpinski Triangle  Fractal
**Simulation Published
M. A. Sandoval-Hernandez, U. A. Filobello-Nino, H. Vazquez-Leal,
O. Alvarez-Gasca, A. D. Contreras-Hernandez, B. E. Palma-Grayeb,
L. Cuellar-Hernandez, N. Carrillo-Ramon, M. Garcia-Lozano,
S.E. Torreblanca-Bouchan, Implementation of the Sierpinsky Triangle with Pic
Microcontroller, International Journal of Engineering Research & Technology,
1(01),2022.*/

/*This program was implemented in the Easypic V7 Connectivity development
board of MikroElektronika.*/
// Glcd module connections
char GLCD_DataPort at PORTD;

sbit GLCD_CS1 at RB0_bit;
sbit GLCD_CS2 at RB1_bit;
sbit GLCD_RS  at RB2_bit;
sbit GLCD_RW  at RB3_bit;
sbit GLCD_EN  at RB4_bit;
sbit GLCD_RST at RB5_bit;

sbit GLCD_CS1_Direction at TRISB0_bit;
sbit GLCD_CS2_Direction at TRISB1_bit;
sbit GLCD_RS_Direction  at TRISB2_bit;
sbit GLCD_RW_Direction  at TRISB3_bit;
sbit GLCD_EN_Direction  at TRISB4_bit;
sbit GLCD_RST_Direction at TRISB5_bit;
// End Glcd module connections

   void Tone1() {
   LATE.F0=0;
  Sound_Play(800, 2000); // Frec = 800Hz, time = 2000ms
}

unsigned  long i,ii, x=0,y=0;
double dd, doub;
void main()
  {
    //16MHz Internal Oscillator Frequency Select bits  Pic18F45k22
   OSCCON.IRCF0=1;
   OSCCON.IRCF1=1;
   OSCCON.IRCF2=1;
   
   /* IRCF<2,1,0>: Internal RC Oscillator Frequency Select bits:
      111 = HFINTOSC     (16MHz)
      110 = HFINTOSC/2   (8MHz)
      101 = HFINTOSC/4   (4MHz)
      100 = HFINTOSC/8   (2MHz)
      011 = HFINTOSC/16  (1MHz default output frequency of HFINTOSC on Reset)
   */
    //PLL Enable or Disable
    PLLEN_bit = 0; // 0 Off   1 On      16MHz x 4=32MHz
   
   // uncomment for pic16f887
   // ANSEL  = 0;    // Configure AN pins as digital    PIC16F887
   // ANSELH = 0;     // Configure AN pins as digital    PIC16F887

   //   configura a digital puertos en pic18f45k22
   ANSELA =0;                              // Configure AN pins as digital I/O
   ANSELB =0;
   ANSELC =0;
   ANSELD =0;
   ANSELE =0;

   TRISE.F0=0;
   TRISC.F2=0;
   Sound_Init(&PORTC, 2);
  // Tone1();
   Glcd_Init();                                   // Initialize GLCD
   Glcd_Fill(0x00);                               // Clear GLCD
   while(1)
    {
      // LATA=0XFF;
      Tone1();
      x=64;
      y=32;
      i=0  ;
      ii=0;
      dd=0;
      doub=0;

      delay_ms(200);

      {
       for(ii=0;ii<200000;ii++)
       {
         LATE.F0=1;

         doub = modf(rand()/10000, &dd);

         if(dd==0)  //vertice medio superior
           {
             x=(x+64)/2;       //64
             y=y/2;
           }
         else if(dd==1)    //vertice inferior derecho
           {
             x=(x+128)/2;     // 128
             y=(y+64)/2;       //64
           }
         else if(dd==2)     //Vertice inferior izquierdo
           {
             x=x/2;
             y=(y+64)/2;      //64
            }
         Glcd_Dot( x, y, 1);
         if(i%1000==0)
            delay_mS(40);
         }
        }
    }
  }